window.addEventListener("load", function(e) { timeshift.onLoad(e); }, false);

var timeshift = {
	onLoad: function()
	{
		var appcontent = document.getElementById("appcontent");   // browser
		if (appcontent)
		{
			appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, false);
		}
	},

	onPageLoad: function(aEvent) 
	{
		var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
		var doc2 = document;

		try
		{
			if (doc!=doc2)
			{
				if (doc==null)
				{
					doc=doc2;
					//alert("doc was null, using document instead.");
				} else if (doc.location==null)
				{
					doc=doc2;
					//alert("doc.location was null, using document instead.");
				} else if (doc.location.href==null) 
				{
					doc=doc2;
					//alert("doc.location.href was null, using document instead.");
				}
			}
			if (doc==null)
			{
			//	alert("doc is null.");
				return;
			} else if (doc.location==null)
			{
			//	alert("doc.location is null.");
				return;
			} else if (doc.location.href==null)
			{
			//	alert("doc.location.href is null");
				return;
			}
		}
		catch (e)
		{
			 //alert("TimeShift Error while loading page:"+e);
		}
		try
		{
			var preferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			preferences = preferences.getBranch("extensions.timeshift.");
			try {var optionSites = preferences.getCharPref("sites");						}catch (err) {err = "InitLoad1:"+err; /*alert(err);*/}
			try {var optionDateFormat = preferences.getCharPref("DateFormat");				}catch (err) {err = "InitLoad1:"+err; /*alert(err);*/}
			try {var optionTimeFormat = preferences.getCharPref("TimeFormat");				}catch (err) {err = "InitLoad1:"+err; /*alert(err);*/}
		} catch(err){err = "InitLoad2:"+err; /*alert(err);*/}

		/* If options are set then continue */
		if (optionSites != "" && optionDateFormat != "" && optionTimeFormat != "")
		{
			var thisSite = doc.location.href;
			var siteStrings = optionSites.split(".NEXT.");
			var siteShift = false;
			for(var i=0; i < siteStrings.length; i++)
			{
				var items = siteStrings[i].split(".ITEM.");
				if (thisSite.search(items[0]) > -1)
				{
					siteShift = true;
					var site = items[0];
					var offset = items[1];
					var format = items[2];
				}
			}
			if (siteShift)
			{	
				var doc_body = doc.body;  //  Get the body node (we don't want to stuff around with headers)
				timeshift_findText(doc, doc_body, offset, format, optionDateFormat, optionTimeFormat);  //  Start the search
			}
		}
	},
}

function timeshift_findText(doc, node, offset, format, optionDateFormat, optionTimeFormat)
{
        var
        textNodes = doc.evaluate("//text()", node, null, 6, null),
        textNode,
        i = 0;

        for (i; textNode = textNodes.snapshotItem(i); i++) {
					if (textNode.parentNode.nodeName != 'SCRIPT')  //  Do not stuff with anything inside a script
					{
						timeshift_replaceDates(textNode, offset, format, optionDateFormat, optionTimeFormat);
					}
        } 
}

// Searches text nodes for dates and or times to shift
function timeshift_replaceDates(node, offset, format, optionDateFormat, optionTimeFormat)
{
	var node_date = node.nodeValue.match(/(?:(?:(?:SUN|MON|TUE(?:S)?|WED(?:NES)?|THU(?:RS)?|FRI|SAT(?:UR)?)(?:DAY)?(?:&NBSP;|\s)*)?(?:\d{1,2}(?:\/\d{1,2}\/|(?:ST|ND|RD|TH|&NBSP;|\s)*(?:JAN(?:UARY)*|feb(?:RUARY)*|MAR(?:CH)*|APR(?:IL)*|MAY|JUN(?:E)*|JUL(?:Y)*|AUG(?:UST)*|SEP(?:T(?:EMBER)*)*|OCT(?:OBER)*|NOV(?:EMBER)*|DEC(?:EMBER)*)(?:&NBSP;|\s)*)\d{2,2}(?:\d{2,2})?)|\d{2,2}(?:\d{2,2})?-\d{2,2}-\d{2,2})(?:&NBSP;|\s)*(?:(?:\d{1,2}:){1,2}\d{1,2}(?:(?:&NBSP;|\s)*[AP]+M?)?)?|(?:(?:\d{1,2}:){1,2}\d{1,2}(?:(?:&NBSP;|\s)*[AP]+M?)?)/gi);  // Get the dates and or times from the node
	if (node_date != null)
	{
		for (var i = 0; i < node_date.length; i++)  // Loop through the dates and/or times
		{
			node_date[i] = node_date[i].replace(/^(?:\s|&nbsp;)+/g, '').replace(/(?:\s|&nbsp;)+$/g, '');  //  Strip any leading or trailing white space characters the regexp may have picked up
			var stringDate = '1/1/1'; // Set the base date, only needed because you cannot create a date object with just a time in Javascript
			var shiftDate = false; // Only becomes true if there is a date to shift
			var node_date_part = node_date[i].match(/(\d{1,2})\/(\d{1,2})\/(\d{2,2}(?:\d{2,2})?)/);  //  Look for dd/mm/yy(yy) or mm/dd/yy(yy) dates
			if (node_date_part != null)
			{
				if (format == 2)  // If site uses US format
				{
					stringDate = node_date_part[1] + '\/' + node_date_part[2] + '\/' + timeshift_fixShortYear(node_date_part[3]);
				} else  // It uses non US
				{
					stringDate = node_date_part[2] + '\/' + node_date_part[1] + '\/' + timeshift_fixShortYear(node_date_part[3]);
				}
				shiftDate = true;
			} else
			{
				var node_date_part = node_date[i].match(/(\d{1,2})(?:ST|ND|RD|TH|&NBSP;|\s)*((?:JAN(?:UARY)*|feb(?:RUARY)*|MAR(?:CH)*|APR(?:IL)*|MAY|JUN(?:E)*|JUL(?:Y)*|AUG(?:UST)*|SEP(?:T(?:EMBER)*)*|OCT(?:OBER)*|NOV(?:EMBER)*|DEC(?:EMBER)*))(?:&NBSP;|\s)*(\d{2,2}(?:\d{2,2})?)/i);  //  Look for dd mmm(m) yy(yy) dates
				if (node_date_part != null)
				{
					stringDate = node_date_part[1] + ' ' + node_date_part[2] + ' ' + timeshift_fixShortYear(node_date_part[3]);
					shiftDate = true;
				} else
				{
					var node_date_part = node_date[i].match(/(\d{2,2}(?:\d{2,2})?)-(\d{2,2})-(\d{2,2})/);  //  Look for (yy)yy-mm-dd dates
					if (node_date_part != null)
					{
						stringDate = node_date_part[2] + '\/' + node_date_part[3] + '\/' + timeshift_fixShortYear(node_date_part[1]);
						shiftDate = true;
					}
				}
			}
			var shiftTime = false;  // Only becomes true if there is a time to shift
			var node_date_time_part = node_date[i].match(/((?:\d{1,2}:){1,2}\d{1,2})(?:(?:&NBSP;|\s)*([AP]+M?))?/);  // Get the useful bits of the string
			if (node_date_time_part != null)
			{
				node_date_time_part.shift();  // Get rid of the whole time string from the array
				stringDate += ' ' + node_date_time_part.join(' ');  // Join the time back together with only a space between the time and the am/pm
				var node_date_time_precision = stringDate.split(':');  // Split the time so we can figure the precision
				var timePrecision = node_date_time_precision.length + 2;  // The precision eg hh:mm or hh:mm:ss etc
				shiftTime = true;
			}
			var tempDate = new Date(stringDate);  // Create a javascript date
			if (shiftTime)  // If there is a time component
			{
				tempDate = new Date(Number(tempDate) + offset*60*60*1000);  // Apply the offset
			}
			var newDate = '';  // Create the string which will replace the original date and/or time
			if (shiftDate)  // If there is a date component
			{
				newDate += timeshift_formatDate(tempDate, optionDateFormat);  // Format it
				if (shiftTime)
				{
					newDate += ' '; // Add a normal space between date and time
				}
			}
			if (shiftTime)  // If there is a time component
			{
				newDate += timeshift_formatTime(tempDate, optionTimeFormat, timePrecision);  // Format it
			}
			node.nodeValue = node.nodeValue.replace(node_date[i], newDate);  // Replace the original date and/or time with the new one
		}
	}
}

// Formats the date to the specified format
function timeshift_formatDate(sourceDate, optionDateFormat)
{
	var sourceDay = sourceDate.getDate();
	var sourceMonth = sourceDate.getMonth() + 1;
	var sourceYear = sourceDate.getFullYear();
	if (optionDateFormat == 1)
	{
		dateReturn = timeshift_leadingZero(sourceDay) + '\/' + timeshift_leadingZero(sourceMonth) + '\/' + sourceYear;
	} else if (optionDateFormat == 2)
	{
		var dateReturn = sourceDay + '\u00a0' + timeshift_MonthReturn(sourceMonth, 'abbr') + '\u00a0' + sourceYear;
	} else if (optionDateFormat == 3)
	{
		var dateReturn = sourceDay + '\u00a0' + timeshift_MonthReturn(sourceMonth, 'full') + '\u00a0' + sourceYear;
	} else if (optionDateFormat == 4)
	{
		var dateReturn = sourceYear + '-' + timeshift_leadingZero(sourceMonth) + '-' + timeshift_leadingZero(sourceDay);
	} else if (optionDateFormat == 5)
	{
		dateReturn = timeshift_leadingZero(sourceMonth) + '\/' + timeshift_leadingZero(sourceDay) + '\/' + sourceYear;
	}
	return dateReturn;
}

// Formats the time to the specified format
function timeshift_formatTime(sourceTime, optionTimeFormat, timePrecision)
{
	var timeHours = sourceTime.getHours();
	var timeEnd = '';
	if (optionTimeFormat == 2)
	{
		timeEnd += '\u00a0';
		if (timeHours < 12)
		{
			timeEnd += timeshift_TimeAMPM('am');
		} else
		{
			timeHours = timeHours - 12;
			timeEnd += timeshift_TimeAMPM('pm');
		}
		if (timeHours == 0)
		{
			timeHours = 12;
		}
	}
	var timeReturn = timeshift_leadingZero(timeHours) + ':' + timeshift_leadingZero(sourceTime.getMinutes());
	if (timePrecision >= 3)
	{
		timeReturn += ':' + timeshift_leadingZero(sourceTime.getSeconds());
	}
	timeReturn += timeEnd;
	return timeReturn;
}

// If the year is expressed as 06 instead of 2006 then fix that
function timeshift_fixShortYear(sourceYear)
{
	sourceReturn = String(sourceYear);
	if (sourceReturn.length <= 2) // if it is a short year
	{
		if (Number(sourceYear) < 80)  //  Use 1980 as the cut off for 19's
		{
			sourceReturn = '20' + sourceReturn;
		} else
		{
			sourceReturn = '19' + sourceReturn;
		}
	}
	return sourceReturn;
}

// Add a leading zero to single digit numbers eg 5 becomes 05
function timeshift_leadingZero(sourceNumber)
{
	var tempNumber = '00' + String(sourceNumber);
	var returnNumber = tempNumber.substr(tempNumber.length - 2);
	return returnNumber;
}

// Get local month names
function timeshift_MonthReturn(sourceMonth, sourceType)
{
	var stringsBundle = document.getElementById('string-bundle');
	var returnMonth = stringsBundle.getString('month_' + String(sourceMonth) + '_' + sourceType);
	return returnMonth;
}

// Get local am/pm names
function timeshift_TimeAMPM(sourceType)
{
	var stringsBundle = document.getElementById('string-bundle');
	var returnAMPM = stringsBundle.getString('time_' + sourceType);
	return returnAMPM;
}
